{ $Id: WMSTestGUI.pas,v 1.19 2003/12/08 08:32:54 msr Exp $

  Copyright (C) 2003 Sourcepole AG.  All rights reserved.
}
{ test gui with the installed components @link(TCmpWMSClient) and @link(TMapViewer) }
unit WMSTestGUI;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, QActnList, QMenus, QExtCtrls, StrUtils,
  IdBaseComponent, IdAntiFreezeBase, IdAntiFreeze, GISClient, CmpWMSClient,
  CmpMapViewer, CmpMSClient, QT, CustomCmpClient,
  DlgBrowserDialog, DlgPictureViewDialog;

type
  // GUI to test the installed components @link(TCmpWMSClient) and @link(TMapViewer)
  TFrmMSTestGUI = class(TForm)
    mmWMSClient: TMainMenu;
    miFile: TMenuItem;
    miExit: TMenuItem;
    aclWMSClient: TActionList; 
    actExit: TAction; 
    actCapabilities: TAction;
    actMap: TAction;  
    actInfo: TAction;
    actGetMapRequest: TAction;
    actGetInfoRequest: TAction;
    actExecMapRequest: TAction;
    actExecInfoRequest: TAction; 
    actImgGetMap: TAction;
    actImgZoomIn: TAction;
    actImgZoomOut: TAction; 
    actImgFullExtend: TAction;
    actImageZoomIn: TAction;
    actImgRefreshMap: TAction;
    stbMapServer: TStatusBar;
    pgcWMSClient: TPageControl;
    tbcImage: TTabSheet;
    tbcConfigWMS: TTabSheet;
    tbcLog: TTabSheet;
    memLog: TMemo;
    btnMapRequestDefault: TButton;   
    btnInfoRequestDefault: TButton;
    btnGetCap: TButton;   
    btnExecMapRequest: TButton;
    btnExecInfoRequest: TButton;  
    btnGetMap: TButton;
    btnGetInfo: TButton;  
    btnZoomIn: TButton;
    btnZoomOut: TButton;
    btnFullExtend: TButton;
    btnRefresh: TButton;
    chkNavBtn: TCheckBox;
    chkNavImg: TCheckBox;
    edtMapRequest: TEdit;
    edtInfoRequest: TEdit;
    edtMinX: TEdit;
    edtMaxX: TEdit;
    edtMinY: TEdit;
    edtMaxY: TEdit;
    edtPosX: TEdit;
    edtPosY: TEdit;
    edtLayers: TEdit;
    edtImageFormat: TEdit;
    edtStyles: TEdit;
    edtVersion: TEdit; 
    edtSRS: TEdit;
    edtQueryLayers: TEdit;
    lblUrl: TLabel;
    lblMapRequest: TLabel;
    lblInfoRequest: TLabel;
    lblLayerList: TLabel;
    lblImageFormat: TLabel;
    lblStyle: TLabel;
    lblMinX: TLabel;
    lblMaxX: TLabel;
    lblMinY: TLabel;
    lblMaxY: TLabel;
    lblPosX: TLabel;
    lblPosY: TLabel;
    lblVersion: TLabel;
    lblSRS: TLabel;
    lblQueryLayers: TLabel;
    pnlImageTop: TPanel;
    rgMode: TRadioGroup;
    wmsClient: TCmpWMSClient;
    umnClient: TCmpUMNClient;
    mapViewer: TMapViewer;
    antiFreeze: TIdAntiFreeze;
    edtUrl: TEdit;
    pnlLogButton: TPanel;
    btnClear: TButton;
    btnGetLegend: TButton;
    lblLegendLayer: TLabel;
    edtLegendLayer: TEdit;
    btnGetOverviewMap: TButton;
    actGetOverviewMap: TAction;
    rgMapServer: TRadioGroup;
    actBeforeGetMap: TAction;
    actBeforeGetInfo: TAction;
    actBeforeGetOverviewmap: TAction;
    actAfterGetMap: TAction;
    actAfterGetInfo: TAction;
    actAfterGetOverviewMap: TAction;
    actGetLegend: TAction;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    procedure actCapabilitiesExecute(Sender: TObject);
    procedure actMapExecute(Sender: TObject);
    procedure actGetMapRequestExecute(Sender: TObject);
    procedure actExecMapRequestExecute(Sender: TObject);
    procedure actImgGetMapExecute(Sender: TObject);
    procedure actImgZoomInExecute(Sender: TObject);
    procedure actImgZoomOutExecute(Sender: TObject);
    procedure actImgFullExtendExecute(Sender: TObject);
    procedure actImgRefreshMapExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkNavBtnClick(Sender: TObject);
    procedure chkNavImgClick(Sender: TObject);
    procedure rgModeClick(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure actGetInfoRequestExecute(Sender: TObject);
    procedure actExecInfoRequestExecute(Sender: TObject);
    procedure actInfoExecute(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure actGetOverviewMapExecute(Sender: TObject);
    procedure rgMapServerClick(Sender: TObject);
    procedure actBeforeGetMapExecute(Sender: TObject);
    procedure actBeforeGetInfoExecute(Sender: TObject);
    procedure actBeforeGetOverviewmapExecute(Sender: TObject);
    procedure actAfterGetMapExecute(Sender: TObject);
    procedure actAfterGetInfoExecute(Sender: TObject);
    procedure actAfterGetOverviewMapExecute(Sender: TObject);
    procedure actGetLegendExecute(Sender: TObject);
  private
    { Private-Deklarationen } 
    FFirstRunWMS1: Boolean;
    FFirstRunUMN1: Boolean;

    FActualiseBeforeExecute: Boolean;

    procedure initMapServer(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  // test GUI TForm
  FrmMSTestGUI: TFrmMSTestGUI;

implementation

{$R *.xfm}   

procedure TFrmMSTestGUI.FormCreate(Sender: TObject);
begin
  FFirstRunWMS1 := true;
  FFirstRunUMN1 := true;

  FActualiseBeforeExecute := false;

  initMapServer(Sender);
end;

// config actions

procedure TFrmMSTestGUI.actCapabilitiesExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Capabilities Request ...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting Url');
  mapViewer.MAPClient.Url := edtUrl.Text;

  memLog.Lines.Add('--- GetCapabilities');
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).GetCapabilities;

    memLog.Lines.Add('--- Receive the capabilities string');
    memLog.Lines.Add((mapViewer.MAPClient as TCmpWMSClient).Capabilities);
  end
  else
    memLog.Lines.Add('--- Not possible with this map server, try the other');

  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actMapExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Map Request ...';
                                                   
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  mapViewer.MAPClient.ImageWidth := mapViewer.Width - 10;  
  mapViewer.MAPClient.ImageHeight := mapViewer.Height - 10;
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
  end;

  memLog.Lines.Add('--- Get Map');
  mapViewer.MAPClient.GetMap;
  mapViewer.LoadMap(mapViewer.MAPClient.Map);

  memLog.Lines.Add('--- Map Request');
  memLog.Lines.Add(mapViewer.MAPClient.MapRequest);
  edtMapRequest.Text := mapViewer.MAPClient.MapRequest;

  memLog.Lines.Add('--- Map');
  mapViewer.Bitmap := mapViewer.MAPClient.Map;
  
  stbMapServer.Panels[0].Text := 'Ready';
end;     

procedure TFrmMSTestGUI.actGetLegendExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Get Legend ...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
    (mapViewer.MAPClient as TCmpWMSClient).LegendLayer := edtLegendLayer.Text;
  end;

  memLog.Lines.Add('--- Get Legend');
  mapViewer.MAPClient.GetLegend;
  dlgPictureView := TDlgPictureView.Create(self);
  dlgPictureView.ImageAsBitmap := mapViewer.MAPClient.Legend;
  dlgPictureView.ShowModal;

  memLog.Lines.Add('--- Legend Request');
  memLog.Lines.Add(mapViewer.MAPClient.LegendRequest);

  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actInfoExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Info Request ...';
                                                 
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  mapViewer.MAPClient.InfoLayers := edtQueryLayers.Text;
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
  end;

  memLog.Lines.Add('--- Get Info');
  mapViewer.MAPClient.GetInfo(StrToInt(edtPosX.text), StrToInt(edtPosY.Text));

  memLog.Lines.Add('--- Info Request');
  memLog.Lines.Add(wmsClient.InfoRequest);
  edtInfoRequest.Text := mapViewer.MAPClient.InfoRequest;

  memLog.Lines.Add('--- Info ' + #13#10 + mapViewer.MAPClient.Info.Text);
  
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actGetMapRequestExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Get Map Request ...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
  end;

  memLog.Lines.Add('--- Get Map Request');
  mapViewer.MAPClient.GetMapRequest;
  memLog.Lines.Add('--- Map Request');
  memLog.Lines.Add(mapViewer.MAPClient.MapRequest);
  edtMapRequest.Text := mapViewer.MAPClient.MapRequest;

  stbMapServer.Panels[0].Text := 'Ready';
end; 

procedure TFrmMSTestGUI.actGetInfoRequestExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Get Info Request ...';
                                               
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
  end;

  memLog.Lines.Add('--- Get Info Request');
  mapViewer.MAPClient.GetInfoRequest(StrToInt(edtPosX.text), StrToInt(edtPosY.Text));
  memLog.Lines.Add('--- Info Request');
  memLog.Lines.Add(mapViewer.MAPClient.InfoRequest);
  edtInfoRequest.Text := mapViewer.MAPClient.InfoRequest;

  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actExecMapRequestExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Exec Map Request ...';
                                         
  memLog.Lines.Add('--------------------------------------------------------');
  mapViewer.MAPClient.MapRequest := edtMapRequest.Text;
  memLog.Lines.Add('--- Exec Map Request');
  mapViewer.MAPClient.ExecMapRequest;
  mapViewer.LoadMap(mapViewer.MAPClient.Map);

  stbMapServer.Panels[0].Text := 'Ready';
end;  

procedure TFrmMSTestGUI.actExecInfoRequestExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Exec Info Request ...';
                            
  memLog.Lines.Add('--------------------------------------------------------');
  mapViewer.MAPClient.InfoRequest := edtInfoRequest.Text;
  memLog.Lines.Add('--- Exec Info Request');
  mapViewer.MAPClient.ExecInfoRequest;
  memLog.Lines.Add('--- Info' + #13#10 + mapViewer.MAPClient.Info.Text);

  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actGetOverviewMapExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Get Overview ...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object');
  mapViewer.MAPClient.Url := edtUrl.Text;
  mapViewer.MAPClient.Layers := edtLayers.Text;
  mapViewer.MAPClient.Version := edtVersion.Text;
  mapViewer.MAPClient.MinX := StrToFloat(edtMinX.Text);
  mapViewer.MAPClient.MaxX := StrToFloat(edtMaxX.Text);
  mapViewer.MAPClient.MinY := StrToFloat(edtMinY.Text);
  mapViewer.MAPClient.MaxY := StrToFloat(edtMaxY.Text);
  if rgMapServer.ItemIndex = 0 then
  begin
    (mapViewer.MAPClient as TCmpWMSClient).ImageFormat := edtImageFormat.Text;
    (mapViewer.MAPClient as TCmpWMSClient).Style := edtStyles.Text;
    (mapViewer.MAPClient as TCmpWMSClient).SRS := edtSRS.Text;
  end;

  memLog.Lines.Add('--- Get Overview Request');
  mapViewer.NavigationImageOn := true;   // FIXME: workaround
  chkNavImg.Checked := true;
  
  memLog.Lines.Add('--- Overview Request');
  memLog.Lines.Add(mapViewer.MAPClient.OverviewMapRequest);

  memLog.Lines.Add('--- Overview');
  mapViewer.Bitmap := mapViewer.MAPClient.OverviewMap;

  stbMapServer.Panels[0].Text := 'Ready';
end;

// image actions

procedure TFrmMSTestGUI.actImgGetMapExecute(Sender: TObject);
begin  
  stbMapServer.Panels[0].Text := 'Start Map ...';
  mapViewer.StartMap;
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actImgZoomInExecute(Sender: TObject);
begin  
  stbMapServer.Panels[0].Text := 'Zoom In ...';
  mapViewer.ZoomIn;  
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actImgZoomOutExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Zoom Out ...';
  mapViewer.ZoomOut;   
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actImgFullExtendExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Full Extend Map ...';
  mapViewer.ZoomToFullExtend;
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actImgRefreshMapExecute(Sender: TObject);
begin
  stbMapServer.Panels[0].Text := 'Refresh Map ...';
  mapViewer.RefreshMap;
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.chkNavBtnClick(Sender: TObject);
begin
  mapViewer.NavigationButtonOn := chkNavBtn.Checked;
end;

procedure TFrmMSTestGUI.chkNavImgClick(Sender: TObject);
begin
  mapViewer.NavigationImageOn := chkNavImg.Checked;
end;

procedure TFrmMSTestGUI.rgModeClick(Sender: TObject);
begin
  if (rgMode.ItemIndex < 1) or (rgMode.ItemIndex > 4) then
    mapViewer.NavigationMode := navNothing;
  if rgMode.ItemIndex = 1 then
    mapViewer.NavigationMode := navZoomIn; 
  if rgMode.ItemIndex = 2 then
    mapViewer.NavigationMode := navZoomOut;
  if rgMode.ItemIndex = 3 then
    mapViewer.NavigationMode := navMove;
  if rgMode.ItemIndex = 4 then
    mapViewer.NavigationMode := navInfo;
end;

procedure TFrmMSTestGUI.actExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFrmMSTestGUI.btnClearClick(Sender: TObject);
begin
  memLog.Clear;
end;

procedure TFrmMSTestGUI.rgMapServerClick(Sender: TObject);
begin
  initMapServer(Sender);
end;

procedure TFrmMSTestGUI.initMapServer(Sender: TObject);
begin
  if rgMapServer.ItemIndex = 0 then
    mapViewer.MAPClient := wmsClient
  else
    mapViewer.MAPClient := umnClient;
    
  edtUrl.Text := mapViewer.MAPClient.Url;
  edtLayers.Text := mapViewer.MAPClient.Layers;
  edtVersion.Text := mapViewer.MAPClient.Version;
  edtMinX.Text := FloatToStr(mapViewer.MAPClient.MinX);
  edtMaxX.Text := FloatToStr(mapViewer.MAPClient.MaxX);
  edtMinY.Text := FloatToStr(mapViewer.MAPClient.MinY);
  edtMaxY.Text := FloatToStr(mapViewer.MAPClient.MaxY);
  edtQueryLayers.Text := mapViewer.MAPClient.InfoLayers;
  edtPosX.Text := IntToStr(Round(mapViewer.Bitmap.Width / 2));
  edtPosY.Text := IntToStr(Round(mapViewer.Bitmap.Width / 2));
  if rgMapServer.ItemIndex = 0 then
  begin                
    edtLegendLayer.Text := (mapViewer.MAPClient as TCmpWMSClient).LegendLayer;
    edtStyles.Text := (mapViewer.MAPClient as TCmpWMSClient).Style;
    edtSRS.Text := (mapViewer.MAPClient as TCmpWMSClient).SRS;
    edtImageFormat.Text := (mapViewer.MAPClient as TCmpWMSClient).ImageFormat;
  end;

  edtLegendLayer.Enabled := rgMapServer.ItemIndex = 0;
  edtStyles.Enabled := rgMapServer.ItemIndex = 0;
  edtSRS.Enabled := rgMapServer.ItemIndex = 0;
  edtImageFormat.Enabled := rgMapServer.ItemIndex = 0;
  btnGetCap.Enabled := rgMapServer.ItemIndex = 0;

  mapViewer.InitMap;
end;

procedure TFrmMSTestGUI.actBeforeGetMapExecute(Sender: TObject);
begin          
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Get Map');
  stbMapServer.Panels[0].Text := 'Get Map ...';
end;

procedure TFrmMSTestGUI.actBeforeGetInfoExecute(Sender: TObject);
begin          
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Get Info');
  stbMapServer.Panels[0].Text := 'Get Info ...';
end;

procedure TFrmMSTestGUI.actBeforeGetOverviewmapExecute(Sender: TObject);
begin                 
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Get Overview Map');
  stbMapServer.Panels[0].Text := 'Get Overview Map ...';
end;

procedure TFrmMSTestGUI.actAfterGetMapExecute(Sender: TObject);
begin
  memLog.Lines.Add('--- Map Request: ' + mapViewer.MAPClient.MapRequest);
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actAfterGetInfoExecute(Sender: TObject);
begin 
  dlgBrowser := TDlgBrowser.Create(self);
  dlgBrowser.text := mapViewer.MAPClient.Info.Text;
  dlgBrowser.NewRequest := mapViewer.MAPClient.InfoRequest;
  dlgBrowser.ShowModal;
  memLog.Lines.Add('--- Get Info Request: ' + mapViewer.MAPClient.InfoRequest);
  memLog.Lines.Add('--- Get Info: ' + mapViewer.MAPClient.Info.Text);
  stbMapServer.Panels[0].Text := 'Ready';
end;

procedure TFrmMSTestGUI.actAfterGetOverviewMapExecute(Sender: TObject);
begin
  memLog.Lines.Add('--- Get Overview Map Request: ' +
    mapViewer.MAPClient.OverviewMapRequest);
  stbMapServer.Panels[0].Text := 'Ready';
end;

end.
